package paraphylo.dao;

import java.util.ArrayList;
import java.util.List;

public class Node {

	Node parent;
	List<Node> children;
	List<Integer> childIds;
	String name;
	String value;
	
	public Node (Node parent, List<Integer> childIds){
		this.parent = parent;
		this.children = new ArrayList<Node>();
		this.childIds = childIds;
		this.name = "";
		this.value = "";
	}

	public Node getParent() {
		return parent;
	}

	public void setParent(Node parent) {
		this.parent = parent;
	}

	public List<Node> getChildren() {
		return children;
	}

	public void setChildren(List<Node> children) {
		this.children = children;
	}

	public List<Integer> getChildIds() {
		return childIds;
	}

	public void setChildIds(List<Integer> childIds) {
		this.childIds = childIds;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	@Override
	public String toString() {
		if (this.children.isEmpty()){
			return this.name;
		}
		else {
			String str = "(";
			for (Node child : this.children){
				str += child.toString()+",";
			}
			str = str.substring(0, str.length()-1);
			str += ")";
			if (!this.value.equals("")){
				str += this.value;
			}
			return str;
		}
	}
}
