package paraphylo.converter;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.List;
import java.util.Map;

public class BlastParser {

	public static List<GeneFamily> parse(String dirname, Map<String,Integer> geneFamilyMap, List<GeneFamily> geneFamilies) throws Exception{
		
		if (geneFamilyMap==null){
			throw new Exception("geneFamilyMap has to be initialized");
		}
		if (geneFamilies==null){
			throw new Exception("geneFamilies has to be initialized");
		}
		
		final File bastdir = new File(dirname);
		for (final File file : bastdir.listFiles()) {
	        if (file.isFile() && file.getName().endsWith(".bla")) {
	        	BufferedReader br = new BufferedReader(new FileReader(file));
	        	String line = "";
	        	while ((line = br.readLine()) != null) {
	        		line = line.trim();
	        		if (line.startsWith("#")){
	        			continue;
	        		}
	        		else{
	        			String[] splitLine = line.split("\\t");
	        			String geneA = splitLine[0];
	        			Integer gfA = geneFamilyMap.get(geneA);
	        			if (gfA == null){
	        				continue;
	        			}
	        			String geneB = splitLine[1];
	        			Integer gfB = geneFamilyMap.get(geneB);
	        			if (gfB == null){
	        				continue;
	        			}
	        			if (gfA.equals(gfB)){
	        				GeneFamily geneFamily = geneFamilies.get(gfA.intValue());
	        				int a = geneFamily.getGeneIndex().get(geneA);
	        				int b = geneFamily.getGeneIndex().get(geneB);
	        				geneFamily.getBlastOrthology()[a][b] = 1d;
	        				geneFamily.getBlastOrthology()[b][a] = 1d;
	        			}
	        		}
	        	}
	        	br.close();
	        }
	    }
		
		return geneFamilies;
	}
}
