package paraphylo.converter;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

public class ProteinorthoFileParser {

	public static String[] parse(String filename, Map<String,Integer> geneFamilyMap, List<GeneFamily> geneFamilies) throws Exception{
		
		if (geneFamilyMap==null){
			throw new Exception("geneFamilyMap has to be initialized");
		}
		if (geneFamilies==null){
			throw new Exception("geneFamilies has to be initialized");
		}
		
		BufferedReader br = new BufferedReader(new FileReader(filename));
		String line = br.readLine().trim();
		String[] splitLine = line.split("\\t");
		String[] species = Arrays.copyOfRange(splitLine, 3, splitLine.length);
		
		int geneFamilyId = 0;
		while ((line = br.readLine()) != null) {
			line = line.trim();
		    if (line.startsWith("#")){
		    	continue;
		    }
		    else{
		    	List<String> gfSpeciesList = new ArrayList<String>();
		    	List<String> gfGenesList = new ArrayList<String>();
		    	splitLine = line.split("\\t");
		    	String[] genesPerFamily = Arrays.copyOfRange(splitLine, 3, splitLine.length);
		    	for (int i=0; i<genesPerFamily.length; i++){
		    		String genesPerSpecies = genesPerFamily[i].trim();
		    		if (!genesPerSpecies.equals("*")){
		    			String[] genes = genesPerSpecies.split(",");
		    			for (String gene : genes){
		    				geneFamilyMap.put(gene, geneFamilyId);
		    				gfSpeciesList.add(species[i]);
		    				gfGenesList.add(gene);
		    			}
		    		}
		    	}
		    	String[] gfSpeciesArray = new String[gfSpeciesList.size()];
		    	String[] gfGenesArray = new String[gfGenesList.size()];
		    	geneFamilies.add(new GeneFamily(gfSpeciesList.toArray(gfSpeciesArray), gfGenesList.toArray(gfGenesArray)));
		    	geneFamilyId++;
		    }
		}
		br.close();
		return species;
	}
}
